<?php

namespace FiloBlu\AdminSecurity\Controller\Adminhtml\Tfa;

use Magento\Backend\App\Action;
use Magento\Framework\App\ResponseInterface;
use FiloBlu\AdminSecurity\Api\TrustedManagerInterface;
use FiloBlu\AdminSecurity\Controller\Adminhtml\AbstractAction;

/**
 * @SuppressWarnings(PHPMD.CamelCaseMethodName)
 */
class Revoke extends AbstractAction
{
    /**
     * @var TrustedManagerInterface
     */
    private $trustedManager;

    public function __construct(
        Action\Context $context,
        TrustedManagerInterface $trustedManager
    ) {
        parent::__construct($context);
        $this->trustedManager = $trustedManager;
    }

    /**
     * @inheritdoc
     */
    public function execute()
    {
        $tokenId = $this->getRequest()->getParam('id');
        $userId = $this->getRequest()->getParam('user_id');
        $this->trustedManager->revokeTrustedDevice($tokenId);

        $this->messageManager->addSuccessMessage(__('Device authorization revoked'));
        return $this->_redirect('adminhtml/user/edit', ['user_id' => $userId]);
    }

    /**
     * @inheritdoc
     */
    protected function _isAllowed()
    {
        return parent::_isAllowed() && $this->_authorization->isAllowed('FiloBlu_AdminSecurity::tfa');
    }
}
