<?php

namespace FiloBlu\AdminSecurity\Model;

use FiloBlu\AdminSecurity\Helper\Data;
use Magento\Framework\HTTP\PhpEnvironment\RemoteAddress;
use Magento\Framework\Model\AbstractModel;

class Ip extends AbstractModel
{
    /**
     * @var RemoteAddress
     */
    private $remoteAddress;

    /**
     * @var Data
     */
    private $helper;

    /**
     * @param RemoteAddress $remoteAddress
     * @param Data $helper
     */
    public function __construct(
        RemoteAddress $remoteAddress,
        Data          $helper
    )
    {
        $this->remoteAddress = $remoteAddress;
        $this->helper = $helper;
    }

    /**
     * Retrieve User IP
     *
     * @return string
     */
    public function getCurrentIp()
    {
        return $this->remoteAddress->getRemoteAddress();
    }

    /**
     * @return bool
     */
    public function isIpInWhiteList()
    {
        $ipList = explode(' ', $this->helper->getWhiteListIp());

        if(!empty($ipList))
        {
            $currentIp = $this->getCurrentIp();
            foreach ($ipList as $ip) {
                if($currentIp == $ip) {
                    return true;
                }
            }
        }

        return false;
    }
}
